;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Addressable RGB LED PWM controller
; servo driver test
; servo1
; 22/10/2007
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        
_isr	movwf	Wisr	
	swapf	STATUS,W		
	clrf	STATUS	
	movwf	Sisr

	movfw	PORTC
	andlw	~(1<<servo1 | 1<<servo2 | 1<<servo3)
	movwf	PORTC	; 10uS from TMR1 int flag set

	bcf	T1CON, TMR1ON
	bcf	PIR1, TMR1IF

	rrf	servoState,f
	bc	_servoGap
		
	movlw	0xFE
	movwf	TMR1H

	
	btfsc	servoState, 0
	movfw	s1pos
	btfsc	servoState, 1
	movfw	s2pos
	btfsc	servoState, 2
	movfw	s3pos
	xorlw	0xFF
	addlw	0x09
	movwf	TMR1L
	skpnc
	incf	TMR1H,F

	movfw	PORTC
	andlw	~(1<<servo1 | 1<<servo2 | 1<<servo3)
	iorwf	servoState,W
	movwf	PORTC
	bsf	T1CON, TMR1ON

_exitInt	swapf	Sisr,W	
	movwf	STATUS	
	swapf	Wisr,F	
	swapf	Wisr,W	
	retfie
	

_servoGap	movlw	b'00001000'
	movwf	servoState
	movlw	0xF2
	movwf	TMR1H
	clrf	TMR1L
	bsf	T1CON,TMR1ON
	goto	_exitInt



	
	
	bsf 	PIE1, TMR1IE	; bank 1

	; leave GIE disabled until first servo data received transfered
	; add servo transfer command

	; set commands so colour transfer clears servo new data flag and vice versa


	